import numpy as np
from PIL import Image
from PIL import ImageDraw, ImageFont
from math import ceil
import sys
import re
import json

def analyzeit(img,fnt,fname):
 aax =363
 aay = 230 
 wdim = 68
 ldim = 181
 box = (aax,aay,aax+wdim,aay+ldim)
 barea = img.crop(box)
 aax =437
 box = (aax,aay,aax+wdim,aay+ldim)
 sarea = img.crop(box)
 bpsig = barea.crop((35, 10, 38, 170))
 bdatt = analyzelane(barea.crop((35, 10, 38, 170)),barea,fname)
 bpsig = sarea.crop((32, 10, 35, 170))
 drawimage(bdatt,"notemplate",35,38,barea,fname)
 sdatt = analyzelane(sarea.crop((32, 10, 35, 170)),sarea,fname)
 drawimage(sdatt,"template",32,35,sarea,fname)
 writejson(bdatt,sdatt,fname)

def writejson(bdatt,sdatt,fname):
 datt = {}
 datt['filename'] =re.sub('.\\\\', '', fname)
 datt['bdatt'] = bdatt
 datt['sdatt'] = sdatt
 try: 
  pgg = open('sigs.json')
  ddd = json.load(pgg)
  pgg.close()
 except:
  ddd = {}
  ddd['data'] = []
 ddd['data'].append(datt)
 #print(ddd)
 datar = json.dumps(ddd)
 gg = open('sigs.json','w')
 gg.write(datar)
 gg.close()

def drawimage(datt,nme,px,ex,parea,fname):
 draw = ImageDraw.Draw(parea)
 draw.rectangle((px, 10+np.min(datt['sigrows']), ex, 10+np.max(datt['sigrows'])), fill=None, outline="pink")
 parea.save(nme+"_"+re.sub('\\\\', '', re.sub('.jpg', '', fname))+".png")


def analyzelane(psig,parea,fname):
 draw = ImageDraw.Draw(parea)
 szarea = psig.size
 px = list(psig.getdata())
 dat = np.array(px)
 gdat = []
 rdat = []
 for i in dat:
   rdat.append(i[0])
   gdat.append(i[1])
 #print(gdat)
 ardat = np.reshape(rdat,(szarea[1],szarea[0]))
 agdat = np.reshape(gdat,(szarea[1],szarea[0]))
 #print(agdat[70,0:])
 #print(agdat)
 bsigry=[np.histogram(ardat, bins=2, range=None, density=False, weights=None)]
 #print(bsigry[0][1])
 thresh = (bsigry[0][1][1])
 sigrows = []
 sigs = []
 reg = []
 for i in range(0,szarea[1]):
     if (np.mean(ardat[i,0:]) > thresh):
      ct = ((np.std(ardat[i,0:])/np.mean(ardat[i,0:]))*100)
      if ct < 8:
       reg.append(ardat[i,0:])
       sigs.append(agdat[i,0:])
       gct = ((np.std(agdat[i,0:])/np.mean(agdat[i,0:]))*100)
       if gct <8:
        sigrows.append(i)
 sigrows = np.array(sigrows)
 #print(np.mean(sigs))
 datt = {}
 datt['sigs']= np.mean(sigs)
 datt['sigrows']= sigrows.tolist()
 return datt


img = Image.open(sys.argv[1])
draw = ImageDraw.Draw(img)
fnt = ImageFont.truetype('arial.ttf', 12)
img =img.rotate(-2.8)
analyzeit(img,fnt,sys.argv[1])

